<script lang="ts" setup name="EntCatIndex">
import { ElMessage, ElMessageBox } from 'element-plus'
import EntCat from './components/EntCat.vue'
import { deleteEntCatById, getEntCatByList } from '@/api/system/entCatApi'

const state = reactive({
  loading: false,
  // 表格是否自适应高度
  tableAutoHeight: false,
  // 搜索
  search: {
    keywords: '',
  },
  // 列表数据
  dataList: [],
})

const entCatRef = ref()

const getDataList = async () => {
  state.loading = true
  const { data } = await getEntCatByList({})
  state.dataList = data
  state.loading = false
}

onMounted(() => {
  getDataList()
})

function onCreate() {}

function onEntCatAdd() {
  entCatRef.value.showAddModel()
}

function onEntCatEdit(row: any) {
  const entCatId = row.entCatId
  entCatRef.value.showEditModel(entCatId)
}

function onEntCatDel(row: any) {
  ElMessageBox.confirm(`确认删除「${row.entCatTitle}」吗？`, '确认信息').then(async () => {
    await deleteEntCatById(row.entCatId)
    await getDataList()
    ElMessage.success({
      message: '删除成功',
      center: true,
    })
  }).catch(() => {})
}
</script>

<template>
  <div :class="{ 'absolute-container': state.tableAutoHeight }">
    <page-header title="企业分类">
      <template #content>
        <div>
          系统支持基于企业客户的分类管理
        </div>
      </template>

      <el-button-group>
        <el-button type="primary" size="large" plain @click="onEntCatAdd">
          <template #icon>
            <el-icon>
              <svg-icon name="ep:plus" />
            </el-icon>
          </template>
          新增
        </el-button>
      </el-button-group>
    </page-header>

    <page-main>
      <el-table v-loading="state.loading" class="list-table" :data="state.dataList" border stripe highlight-current-row height="100%">
        <el-table-column type="index" label="序号" width="60" header-align="center" align="center" />

        <el-table-column prop="entCatTitle" label="名称" header-align="center" align="center" width="200" />

        <el-table-column prop="entCatDesc" label="说明" />

        <el-table-column label="操作" width="250" align="center" fixed="right">
          <template #default="scope">
            <el-button type="primary" size="small" plain @click="onEntCatEdit(scope.row)">
              编辑
            </el-button>
            <el-button v-if="!scope.row.isFixed" type="danger" size="small" plain @click="onEntCatDel(scope.row)">
              删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </page-main>
    <EntCat ref="entCatRef" @success="getDataList" />
  </div>
</template>

<style lang="scss" scoped>
.absolute-container {
  position: absolute;
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;

  .page-header {
    margin-bottom: 0;
  }

  .page-main {
    // 让 page-main 的高度自适应
    flex: 1;
    overflow: auto;
    display: flex;
    flex-direction: column;

    .search-container {
      margin-bottom: 0;
    }
  }
}
</style>
